/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package javafx.animations;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.animation.FadeTransition;
import javafx.animation.Interpolator;
import javafx.animation.RotateTransition;
import javafx.animation.SequentialTransition;
import javafx.animation.TranslateTransition;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.shape.Rectangle;
import javafx.util.Duration;

/**
 *
 * @author Phabian
 */
public class FXMLDocumentController implements Initializable {

    @FXML
    private Rectangle animationTarget;


    private RotateTransition rt;
    private FadeTransition ft;
    private TranslateTransition tt;
    private SequentialTransition st;
    
    final Duration SEC_2 = Duration.millis(1500);

    @FXML
    private void handleButtonActionFade(ActionEvent event) {
        ft.play();
    }

    @FXML
    private void handleButtonActionMove(ActionEvent event) {
        tt.play();
    }

    @FXML
    private void handleButtonActionRotate(ActionEvent event) {
            rt.play();
                    

    }
    
    @FXML
    private void handleButtonActionSequential(ActionEvent event) {
        
        System.out.print("CLICK");
        
        //Hier bekommt man ansonsten den Fehler:
        // Cant stop Transition,that ist inside other Transition
        if (st == null){
            rt.stop();
            ft.stop();
            tt.stop();
        }else st.stop();
        
        st = new SequentialTransition(animationTarget,rt,ft,tt);
        st.play();
                
        
    }

    @Override
    public void initialize(URL url, ResourceBundle rb) {
        //Erstelle Rotate Translation
        ft = new FadeTransition(SEC_2, animationTarget);
        ft.setFromValue(1.0);
        ft.setToValue(0.1);
     
        //Erstelle Rotate Translation
        rt = new RotateTransition(SEC_2, animationTarget);
        rt.setFromAngle(0);
        rt.setToAngle(360);
        rt.setInterpolator(Interpolator.EASE_BOTH);
        
        //Erstelle Rotate Translation
        tt = new TranslateTransition(SEC_2,animationTarget);
        tt.setFromX(-50);
        tt.setToX(50);
        tt.setAutoReverse(true);
        tt.setInterpolator(Interpolator.EASE_BOTH);
        
        
        
    }

}
