package javafxapplication8;

import javafx.application.Application;
import javafx.stage.Stage;
import javafx.animation.KeyFrame;
import javafx.animation.KeyValue;
import javafx.animation.Timeline;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;

import javafx.util.Duration;
 
public class JavaFXApplication8 extends Application {
    
    //main timeline
    private Timeline timeline;

 
    //variable for storing actual frame
    private Integer i=0;
 
    @Override public void start(Stage stage) {
        
        Group p = new Group();
        Scene scene = new Scene(p);
        stage.setScene(scene);
        stage.setWidth(200);
        stage.setHeight(500);
        p.setTranslateX(80);
        p.setTranslateY(80);
 
        //Create a  red circle
        final Circle circle = new Circle(30,  Color.rgb(255,0,0));
        
        p.getChildren().add(circle);

        stage.show();
 
        //create a timeline for moving the circle
        timeline = new Timeline();
        timeline.setCycleCount(Timeline.INDEFINITE);
        timeline.setAutoReverse(true);

        MyInterpolator mInterpolator = new MyInterpolator();

        //create a keyvalue 
        KeyValue keyValueY = new KeyValue(circle.translateYProperty(), 200, mInterpolator);

 
        Duration duration = Duration.millis(1000);

 
        
        KeyFrame keyFrame1 = new KeyFrame(duration, keyValueY);
         
         
        timeline.getKeyFrames().addAll(keyFrame1);
 
        timeline.play();

    }
        
        
    public static void main(String[] args) {
        Application.launch(args);
    }
  } 